
include( "IconSupport" );
include( "InstanceManager" );
include( "TutorialPopupScreen" );
include( "GlobalProperties" );

local g_PropertiesIM = InstanceManager:new( "OptionsListInstance", "Root", Controls.OptionsStack );

local sel_MissionOnStart;
local sel_MissionOnEnd;
local sel_AlertFortify ;
local sel_WorkerStopIfDanger ;
local sel_DEBUG ;

function OnPopup()

	print ("LT Options popup. initial status:",g_LTO_MissionOnStart,g_LTO_AlertFortify,g_LTO_WorkerStopIfDanger,g_DEBUG);

	sel_MissionOnStart=g_LTO_MissionOnStart;
	sel_MissionOnEnd=not g_LTO_MissionOnStart;
	sel_AlertFortify=g_LTO_AlertFortify;
	sel_WorkerStopIfDanger=g_LTO_WorkerStopIfDanger;
	sel_DEBUG=g_DEBUG;
	
	UpdateCheckBoxes();
	
	g_PropertiesIM:ResetInstances();

   	--UIManager:QueuePopup( ContextPtr, PopupPriority.NotificationLog );
	
end


function OnClose ()
    UIManager:DequeuePopup( ContextPtr );
end
Controls.CloseButton:RegisterCallback( Mouse.eLClick, OnClose );


function InputHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
            OnClose();
            return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );


function OnConfirm ()
    UIManager:DequeuePopup( ContextPtr );
	
	--return results to GlobalProperties.lua
	LuaEvents.SetGlobalData({["g_LTO_MissionOnStart"]=sel_MissionOnStart,
							 ["g_LTO_AlertFortify"]=sel_AlertFortify, 
							 ["g_LTO_WorkerStopIfDanger"]=sel_WorkerStopIfDanger, 
							 ["g_DEBUG"]=sel_DEBUG
							});
end
Controls.ConfirmButton:RegisterCallback( Mouse.eLClick, OnConfirm );


-- toggles
function OnRClFortify ()
	sel_AlertFortify= not sel_AlertFortify;
end
Controls.RClFortify:RegisterCallback( Mouse.eLClick, OnRClFortify );

--function OnStopWorkIfDanger ()
--	sel_WorkerStopIfDanger= not sel_WorkerStopIfDanger;
--end
--Controls.StopWorkIfDanger:RegisterCallback( Mouse.eLClick, OnStopWorkIfDanger );

function DBInfo ()
	sel_DEBUG= not sel_DEBUG;
end
Controls.DBInfo:RegisterCallback( Mouse.eLClick, DBInfo );


function OnMissionsOnTurnStart ()
	sel_MissionOnStart = not sel_MissionOnStart;
	sel_MissionOnEnd = not sel_MissionOnStart;
	UpdateCheckBoxes();
end
Controls.MissionsOnTurnStart:RegisterCallback( Mouse.eLClick, OnMissionsOnTurnStart );

function OnMissionsOnTurnEnd ()
	sel_MissionOnEnd = not sel_MissionOnEnd;
	sel_MissionOnStart = not sel_MissionOnEnd;	
	UpdateCheckBoxes();
end
Controls.MissionsOnTurnEnd:RegisterCallback( Mouse.eLClick, OnMissionsOnTurnEnd );

-- update display of selections
function UpdateCheckBoxes()
	Controls.MissionsOnTurnStart:SetCheck(sel_MissionOnStart);		
	Controls.MissionsOnTurnEnd:SetCheck(sel_MissionOnEnd);		
	Controls.RClFortify:SetCheck(sel_AlertFortify);		
	--Controls.StopWorkIfDanger:SetCheck(sel_WorkerStopIfDanger);		
	Controls.DBInfo:SetCheck(sel_DEBUG);		
end


function ShowHideHandler( bIsHide, bInitState )
    if( not bInitState ) then
        if( not bIsHide ) then
			OnPopup();
        	-- UI.incTurnTimerSemaphore();
        	-- Events.SerialEventGameMessagePopupShown(m_PopupInfoLTO);
        else
            -- UI.decTurnTimerSemaphore();
            -- Events.SerialEventGameMessagePopupProcessed.CallImmediate(ButtonPopupTypes.BUTTONPOPUP_NOTIFICATION_LOG, 0);
        end
    end
end
ContextPtr:SetShowHideHandler( ShowHideHandler );

