

include( "IconSupport" );
include( "InstanceManager" );
include( "TutorialPopupScreen" );
include( "GlobalProperties" );

local m_optionsIM = InstanceManager:new( "OptionsListInstance", "Root", Controls.OptionsStack );

local curChoice=1; --default menu choice
local standbyFlag; --default menu choice

--this function is an entry point to be called from WorldView.lua
LuaEvents.ShowWorkerAutomationPopupMenu.Add(
function()
	OnPopup();
end);

-------------------------------------------------
-- On Popup
-------------------------------------------------
function OnPopup()

	standbyFlag = g_WrkStandbyFlag;
	UIManager:QueuePopup( ContextPtr, PopupPriority.NotificationLog );

end


function OnClose()
    UIManager:DequeuePopup( ContextPtr );
	
	--return results to WorldView.lua
	LuaEvents.ClosedWorkerAutomationPopupMenu(nil);	
end
Controls.CloseButton:RegisterCallback( Mouse.eLClick, OnClose);


function InputHandler( uiMsg, wParam, lParam )
    if uiMsg == KeyEvents.KeyDown then
        if wParam == Keys.VK_ESCAPE or wParam == Keys.VK_RETURN then
            OnClose();
            return true;
        end
    end
end
ContextPtr:SetInputHandler( InputHandler );


function OnConfirm()
    UIManager:DequeuePopup( ContextPtr );
	
	--return results to WorldView.lua
	local desiredYield;
	if(curChoice==1) then desiredYield=1;	--prod
	elseif(curChoice==2) then desiredYield=0;	--food
	elseif(curChoice==3) then desiredYield=2;	--gold
	end
	LuaEvents.SetGlobalData({["g_WrkStandbyFlag"]=standbyFlag});
	LuaEvents.ClosedWorkerAutomationPopupMenu(desiredYield);	
end
Controls.ConfirmButton:RegisterCallback( Mouse.eLClick, OnConfirm);


function OnStandby()
    standbyFlag = not standbyFlag;
	UpdateScreen();
end
Controls.StandbyCheckbox:RegisterCallback( Mouse.eLClick, OnStandby );


function MenuOptionClicked(itemNum)
	curChoice=itemNum;   
	UpdateScreen();
end
        

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
function UpdateScreen()

    local iPlayer = Game.GetActivePlayer();
    local pPlayer = Players[ iPlayer ];
   
    m_optionsIM:ResetInstances();

	Controls.StandbyCheckbox:SetCheck(standbyFlag);		
	
	local choices={"[ICON_PRODUCTION] Production", "[ICON_FOOD] Food", "[ICON_GOLD] Gold"};
	for i=1, 3, 1 do
        local instance = m_optionsIM:GetInstance();
               
        instance.Button:RegisterCallback( Mouse.eLClick, MenuOptionClicked );
        instance.Button:SetVoid1( i );
		
        instance.OptionText:LocalizeAndSetText( choices[i] );

		if(i==curChoice) then
			instance.MenuSelectionPip:SetTextureOffsetVal( 0, 0 );
		else
            instance.MenuSelectionPip:SetTextureOffsetVal( 0, 96 );
		end
 
    end

end

    


function ShowHideHandler( bIsHide, bInitState )

	--print("WorkerAutomatePopup ShowHideHandler",bIsHide,bInitState);
    UpdateScreen();

	--I have no idea what any of this is :(
	
   --[[ if( not bInitState ) then
        if( not bIsHide ) then
        	UI.incTurnTimerSemaphore();
			OpenAdvisorPopup(ButtonPopupTypes.BUTTONPOPUP_NOTIFICATION_LOG);
        	Events.SerialEventGameMessagePopupShown(m_PopupInfo);			
        else
            UI.decTurnTimerSemaphore();
            CloseAdvisorPopup(ButtonPopupTypes.BUTTONPOPUP_NOTIFICATION_LOG);
            Events.SerialEventGameMessagePopupProcessed.CallImmediate(ButtonPopupTypes.BUTTONPOPUP_NOTIFICATION_LOG, 0);
        end
    end]]--
end
ContextPtr:SetShowHideHandler( ShowHideHandler );